module RulingTimer
  class Engine < ::Rails::Engine
    initializer "ruling_timer" do
      begin
        puts "ruling_timerruling_timerruling_timer"
        OrbitApp.registration "RulingTimer", :type => "OrbitMemberModule" do
          module_label "ruling_timer.ruling_timer"
          base_url File.expand_path File.dirname(__FILE__)
          authorizable
          categorizable
          taggable "RulingTimerTask"
          side_bar do
            head_label_i18n 'ruling_timer.ruling_timer', icon_class: "icons-clock"
            available_for "users"
            active_for_controllers (['admin/ruling_timers'])
            head_link_path "admin_ruling_timers_path"
            context_link 'ruling_timer.settings',
                                  :link_path=>"settings_admin_ruling_timers_path" ,
                                  :priority=>1,
                                  :active_for_action=>{'admin/ruling_timers'=>'settings'},
                                  :available_for => 'managers'
            context_link 'restful_actions.timer_management',
                                  :link_path=>"timer_management_admin_ruling_timers_path" ,
                                  :priority=>2,
                                  :active_for_action=>{'admin/ruling_timers'=>'timer_management'},
                                  :available_for => 'managers'
            context_link 'restful_actions.task_management',
                                  :link_path=>"task_management_admin_ruling_timers_path" ,
                                  :priority=>3,
                                  :active_for_action=>{'admin/ruling_timers'=>'task_management'},
                                  :available_for => 'managers'
            context_link 'restful_actions.project_management',
                                  :link_path=>"project_management_admin_ruling_timers_path" ,
                                  :priority=>3,
                                  :active_for_action=>{'admin/ruling_timers'=>'project_management'},
                                  :available_for => 'managers'
            context_link 'categories',
                                :link_path=>"admin_module_app_categories_path" ,
                                :link_arg=>"{:module_app_id=>OrbitMemberModule.find_by(:key=>'ruling_timer').id,:module_app_type=>'orbit_member_module'}",
                                :priority=>4,
                                :active_for_action=>{'admin/ruling_timers'=>'categories'},
                                :active_for_category => 'RulingTimer',
                                :available_for => 'managers'
          context_link 'tags',
                                :link_path=>"admin_module_app_tags_path" ,
                                :link_arg=>"{:module_app_id=>OrbitMemberModule.find_by(:key=>'ruling_timer').id,:module_app_type=>'orbit_member_module'}",
                                :priority=>5,
                                :active_for_action=>{'admin/ruling_timers'=>'tags'},
                                :active_for_tag => 'RulingTimer',
                                :available_for => 'managers'
          end
        end
      rescue => e
        puts e.to_s
        puts e.backtrace
        OrbitApp.registration "RulingTimer", :type => "ModuleApp" do
          module_label "ruling_timer.ruling_timer"
          base_url File.expand_path File.dirname(__FILE__)
          authorizable
          categorizable
          taggable "RulingTimerTask"
          side_bar do
            head_label_i18n 'ruling_timer.ruling_timer', icon_class: "icons-clock"
            available_for "users"
            active_for_controllers (['admin/ruling_timers'])
            head_link_path "admin_ruling_timers_path"

            context_link 'restful_actions.timer_management',
                                  :link_path=>"timer_management_admin_ruling_timers_path" ,
                                  :priority=>1,
                                  :active_for_action=>{'admin/ruling_timers'=>'timer_management'},
                                  :available_for => 'managers'
            context_link 'restful_actions.task_management',
                                  :link_path=>"task_management_admin_ruling_timers_path" ,
                                  :priority=>2,
                                  :active_for_action=>{'admin/ruling_timers'=>'task_management'},
                                  :available_for => 'managers'
          end
        end
      end
    end
  end
end
